@import '../../styles/common';

$arrow-size: rem(14px);
$visible-portion-of-arrow: rem(5px);
$content-max-height: rem(500px);
$content-max-width: rem(400px);
$vertical-motion-offset: rem(-5px);

.Popover {
  max-width: calc(100vw - #{2 * spacing()});
  margin: $visible-portion-of-arrow spacing(tight) spacing();
  box-shadow: var(--p-popover-shadow);
  border-radius: var(--p-border-radius-wide);
  will-change: left, top;
}

.PopoverOverlay {
  opacity: 0;
  transition: opacity duration(fast) easing(), transform duration(fast) easing();
  transform: translateY($vertical-motion-offset);
}

.PopoverOverlay-entering {
  opacity: 1;
  transform: translateY(0);
}

.PopoverOverlay-open {
  opacity: 1;
  transform: none;
}

.PopoverOverlay-exiting {
  opacity: 1;
  transform: translateY(0);
  transition-duration: 0ms;
}

.measuring:not(.PopoverOverlay-exiting) {
  opacity: 0;
  transform: translateY($vertical-motion-offset);
}

.fullWidth {
  margin: 0;
  margin-top: $visible-portion-of-arrow;

  .Content {
    max-width: none;
  }
}

.positionedAbove {
  margin: spacing() spacing(tight) $visible-portion-of-arrow;

  &.fullWidth {
    margin: 0 0 $visible-portion-of-arrow;
  }
}

.Wrapper {
  position: relative;
  overflow: hidden;
  background-color: var(--p-surface);
  border-radius: var(--p-border-radius-wide);
  outline: 1px solid transparent;
}

.Content {
  position: relative;
  display: flex;
  flex-direction: column;
  border-radius: var(--p-border-radius-base);
  max-width: $content-max-width;
  max-height: $content-max-height;

  &:focus {
    outline: none;
  }
}

.Content-fullHeight {
  max-height: none;
}

.Content-fluidContent {
  max-height: none;
  max-width: none;
}

.Pane {
  flex: 1 1 0%;
  max-width: 100%;

  + .Pane {
    border-top: border('divider');
  }

  &:focus {
    outline: none;
  }
}

.Pane-fixed {
  overflow: visible;
  flex: 0 0 auto;
}

.Section {
  padding: spacing();

  + .Section {
    border-top: border('divider');
  }
}

.FocusTracker {
  @include visually-hidden;
}

.PopoverOverlay-hideOnPrint {
  @include hidden-when-printing;
}
